/*
 *  Copyright (C) 2013  Thadeu Lima de Souza Cascardo <cascardo@cascardo.info>
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License along
 *  with this program; if not, write to the Free Software Foundation, Inc.,
 *  51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
 */

#include <sgp/share.h>
#include <sgp/channels/printf.h>

int main(int argc, char **argv)
{
	struct sgp_group *group;
	struct sgp_msg *msg;
	struct sgp_friend *friend;
	int r;
	/* TODO: access a database here? */
	friend = sgp_friend_new("Thadeu Cascardo");
	if (!friend)
		return 1;
	sgp_friend_set_channel(friend, sgp_printf_channel());
	group = sgp_group_new("Myself");
	if (!group)
		goto out_group;
	msg = sgp_msg_new("New message for you");
	if (!msg)
		goto out_msg;
	r = sgp_group_add_friend(group, friend);
	if (r)
		goto out_add;
	r = sgp_share(group, msg);
	sgp_msg_destroy(msg);
	sgp_group_destroy(group);
	/* we must only destroy the friend after all group references
	 * are gone */
	sgp_friend_destroy(friend);
	return r;
out_add:
	sgp_msg_destroy(msg);
out_msg:
	sgp_group_destroy(group);
out_group:
	sgp_friend_destroy(friend);
	return 1;
}
